## git-annex 4.20131024

=== Makefile ===
mans=git-annex.1 git-annex-shell.1
all=git-annex $(mans) docs

GHC?=ghc
PREFIX?=/usr
CABAL?=cabal # set to "./Setup" if you lack a cabal program

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: build-stamp
build-stamp: $(all)
	touch $@

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	$(CABAL) configure

git-annex: Build/SysConfig.hs
	$(CABAL) build
	ln -sf dist/build/git-annex/git-annex git-annex

git-annex.1: doc/git-annex.mdwn
	./Build/mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
git-annex-shell.1: doc/git-annex-shell.mdwn
	./Build/mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-recover-repository.1: doc/git-recover-repository.mdwn
	./Build/mdwn2man git-recover-repository 1 doc/git-recover-repository.mdwn > git-recover-repository.1
git-union-merge:
	$(GHC) --make -threaded $@
git-recover-repository:
	$(GHC) --make -threaded $@

install-mans: $(mans)
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

install: build install-docs Build/InstallDesktopFile
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true

test: git-annex
	./git-annex test

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags > tags 2>/dev/null

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: $(mans)
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*'

clean:
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs \
		git-union-merge git-recover-repository
	find -name \*.o -exec rm {} \;
	find -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@

sdist: clean $(mans)
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone: Build/Standalone
	$(MAKE) git-annex

	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux "$(LINUXSTANDALONE_DEST)"

	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/favicon.png doc/logo.svg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	
	touch "$(LINUXSTANDALONE_DEST)/libdirs.tmp"
	for lib in $$(ldd "$(LINUXSTANDALONE_DEST)"/bin/* $$(find "$(LINUXSTANDALONE_DEST)"/git-core/ -type f) | grep -v -f standalone/linux/glibc-libs | grep -v "not a dynamic executable" | egrep '^	' | sed 's/^\t//' | sed 's/.*=> //' | cut -d ' ' -f 1 | sort | uniq); do \
		dir=$$(dirname "$$lib"); \
		install -d "$(LINUXSTANDALONE_DEST)/$$dir"; \
		echo "$$dir" >> "$(LINUXSTANDALONE_DEST)/libdirs.tmp"; \
		cp "$$lib" "$(LINUXSTANDALONE_DEST)/$$dir"; \
		if [ -L "$lib" ]; then \
			link=$$(readlink -f "$$lib"); \
			cp "$$link" "$(LINUXSTANDALONE_DEST)/$$(dirname "$$link")"; \
		fi; \
	done
	sort "$(LINUXSTANDALONE_DEST)/libdirs.tmp" | uniq > "$(LINUXSTANDALONE_DEST)/libdirs"
	rm -f "$(LINUXSTANDALONE_DEST)/libdirs.tmp"

	cd tmp && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"

	./Build/OSXMkLibs $(OSXAPP_BASE)
	rm -f tmp/git-annex.dmg
	hdiutil create -size 640m -format UDRW -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg
	rm -f tmp/git-annex.dmg.bz2
	bzip2 --fast tmp/git-annex.dmg

ANDROID_FLAGS?=-f-XMPP
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS);  fi
	mkdir -p tmp
	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/android/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
	if [ ! -e tmp/androidtree/dist/setup/setup ]; then \
		cd tmp/androidtree && $$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
	fi
	cd tmp/androidtree && $$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal build

adb:
	ANDROID_FLAGS="-Production" $(MAKE) android
	adb push tmp/androidtree/dist/build/git-annex/git-annex /data/data/ga.androidterm/bin/git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# We bypass cabal, and only run the main ghc --make command for a
# fast development built. Note: Does not rebuild C libraries.
fast: dist/caballog
	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/caballog: git-annex.cabal
	$(CABAL) configure -f"-Production" -O0
	$(CABAL) build -v2 | tee $@

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports

.PHONY: git-annex git-union-merge git-recover-repository tags build-stamp

=== debian/changelog ===
git-annex (4.20131024) unstable; urgency=low

  * webapp: Fix bug when adding a remote and git-remote-gcrypt
    is not installed.
  * The assitant can now run scheduled incremental fsck jobs on the local
    repository and remotes. These can be configured using vicfg or with the
    webapp.
  * repair: New command, which can repair damaged git repositories
    (even ones not using git-annex).
  * webapp: When git repository damange is detected, repairs can be
    done using the webapp UI.
  * Automatically and safely detect and recover from dangling
    .git/annex/index.lock files, which would prevent git from
    committing to the git-annex branch, eg after a crash.
  * assistant: Detect stale git lock files at startup time, and remove them.
  * addurl: Better sanitization of generated filenames.
  * Better sanitization of problem characters when generating URL and WORM
    keys.
  * The control socket path passed to ssh needs to be 17 characters
    shorter than the maximum unix domain socket length, because ssh
    appends stuff to it to make a temporary filename. Closes: #725512
  * status: Fix space leak in local mode, introduced in version 4.20130920.
  * import: Skip .git directories.
  * Remove bogus runshell loop check.
  * addurl: Improve message when adding url with wrong size to existing file.
  * Fixed handling of URL keys that have no recorded size.
  * status: Fix a crash if a temp file went away while its size was
    being checked for status.
  * Deal with git check-attr -z output format change in git 1.8.5.
  * Work around sed output difference that led to version containing a newline
    on OSX.
  * sync: Fix automatic resolution of merge conflicts where one side is an
    annexed file, and the other side is a non-annexed file, or a directory.
  * S3: Try to ensure bucket name is valid for archive.org.
  * assistant: Bug fix: When run in a subdirectory, files from incoming merges
    were wrongly added to that subdirectory, and removed from their original
    locations.
  * Windows: Deal with strange msysgit 1.8.4 behavior of not understanding
    DOS formatted paths for --git-dir and --work-tree.
  * Removed workaround for bug in git 1.8.4r0.
  * Added git-recover-repository command to git-annex source
    (not built by default; this needs to move to someplace else).
  * webapp: Move sidebar to the right hand side of the screen.

 -- Joey Hess <joeyh@debian.org>  Thu, 24 Oct 2013 12:59:55 -0400

## git-annex 4.20131101

=== debian/changelog ===
git-annex (4.20131101) unstable; urgency=low

  * The "git annex content" command is renamed to "git annex wanted".
  * New --want-get and --want-drop options which can be used to
    test preferred content settings.
    For example, "git annex find --in . --want-drop"
  * assistant: When autostarted, wait 5 seconds before running the startup
    scan, to avoid contending with the user's desktop login process.
  * webapp: When setting up a bare shared repository, enable non-fast-forward
    pushes.
  * sync: Show a hint about receive.denyNonFastForwards when a push fails.
  * directory, webdav: Fix bug introduced in version 4.20131002 that
    caused the chunkcount file to not be written. Work around repositories
    without such a file, so files can still be retreived from them.
  * assistant: Automatically repair damanged git repository, if it can
    be done without losing data.
  * assistant: Support repairing git remotes that are locally accessible
    (eg, on removable drives).
  * add: Fix reversion in 4.20130827 when adding unlocked files that have
    not yet been committed.
  * unannex: New, much slower, but more safe behavior: Copies files out of
    the annex. This avoids an unannex of one file breaking other files that
    link to the same content. Also, it means that the content
    remains in the annex using up space until cleaned up with 
    "git annex unused".
    (The behavior of unannex --fast has not changed; it still hard links
    to content in the annex. --fast was not made the default because it is
    potentially unsafe; editing such a hard linked file can unexpectedly
    change content stored in the annex.)

 -- Joey Hess <joeyh@debian.org>  Fri, 01 Nov 2013 11:34:27 -0400

## git-annex 4.20131106

=== standalone/android/Makefile ===
# Cross-compiles utilities needed for git-annex on Android,
# and builds the Android app.

# Add Android cross-compiler to PATH (as installed by ghc-android)
ANDROID_CROSS_COMPILER?=$(HOME)/.ghc/android-14/arm-linux-androideabi-4.7/bin
PATH:=$(ANDROID_CROSS_COMPILER):$(PATH)

# Paths to the Android SDK and NDK.
export ANDROID_SDK_ROOT?=$(HOME)/.android/adt-bundle-linux-x86/sdk
export ANDROID_NDK_ROOT?=$(HOME)/.android/android-ndk

# Where to store the source tree used to build utilities. This
# directory will be created by `make source`.
GIT_ANNEX_ANDROID_SOURCETREE?=$(HOME)/.android/git-annex-sourcetree

GITTREE=$(GIT_ANNEX_ANDROID_SOURCETREE)/git/installed-tree

build: start
	if [ ! -e "$(GIT_ANNEX_ANDROID_SOURCETREE)" ]; then $(MAKE) source; fi
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp

	# Debug build because it does not need signing keys.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && tools/build-debug

	# Install executables as pseudo-libraries so they will be
	# unpacked from the .apk.
	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi
	cp ../../tmp/androidtree/dist/build/git-annex/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.busybox.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh-keygen $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh-keygen.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/rsync $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.rsync.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/g10/gpg $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.gpg.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git-shell $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-shell.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git-upload-pack $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-upload-pack.so
	arm-linux-androideabi-strip --strip-unneeded --remove-section=.comment --remove-section=.note $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/*
	cp runshell $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.runshell.so
	cp start $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.start.so
	
	# remove git stuff we don't need to save space
	rm -rf $(GITTREE)/bin/git-cvsserver \
		$(GITTREE)/libexec/git-core/git-daemon \
		$(GITTREE)/libexec/git-core/git-show-index \
		$(GITTREE)/libexec/git-core/mergetools \
		$(GITTREE)/libexec/git-core/git-credential-* \
		$(GITTREE)/libexec/git-core/git-cvsserver \
		$(GITTREE)/libexec/git-core/git-cvsimport \
		$(GITTREE)/libexec/git-core/git-fast-import \
		$(GITTREE)/libexec/git-core/git-http-backend \
		$(GITTREE)/libexec/git-core/git-imap-send \
		$(GITTREE)/libexec/git-core/git-instaweb \
		$(GITTREE)/libexec/git-core/git-p4 \
		$(GITTREE)/libexec/git-core/git-remote-test* \
		$(GITTREE)/libexec/git-core/git-submodule \
		$(GITTREE)/libexec/git-core/git-svn \
		$(GITTREE)/libexec/git-core/git-web--browse
	# Most of git is in one multicall binary, but a few important
	# commands are still shell scripts. Those are put into
	# a tarball, along with a list of all the links that should be
	# set up.
	cd $(GITTREE) && mkdir -p links
	cd $(GITTREE) && find -samefile bin/git -not -wholename ./bin/git > links/git
	cd $(GITTREE) && find -samefile bin/git-shell -not -wholename ./bin/git-shell > links/git-shell
	cd $(GITTREE) && find -samefile bin/git-upload-pack -not -wholename ./bin/git-upload-pack > links/git-upload-pack
	cd $(GITTREE) && find -type f -not -samefile bin/git -not -samefile bin/git-shell -not -samefile bin/git-upload-pack|tar czf ../git.tar.gz -T -
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git.tar.gz $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git.tar.gz.so

	git rev-parse HEAD > $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.version.so

	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
	mkdir -p ../../tmp
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/git-annex.apk

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && CC=$$(which cc) ./Configure android
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/build-stamp: openssh.patch openssh.config.h
	# This is a known-good version that the patch works with.
	# TODO: Upgrade
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && git reset --hard 0a8617ed5af2f0248d0e9648e26b224e16ada742
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && ./configure --host=arm-linux-androideabi --with-ssl-dir=../openssl --without-openssl-header-check
	cat openssh.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && patch -p1)
	cp openssh.config.h $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/config.h
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/getrrsetbyname.o //' openbsd-compat/Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/auth-passwd.o //' Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && $(MAKE) ssh ssh-keygen
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/build-stamp: busybox_config
	cp busybox_config $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/.config
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && yes '' | $(MAKE) oldconfig
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && $(MAKE)
	touch $@
	
$(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/git && $(MAKE) install NO_OPENSSL=1 NO_GETTEXT=1 NO_GECOS_IN_PWENT=1 NO_GETPASS=1 NO_NSEC=1 NO_MKDTEMP=1 NO_PTHREADS=1 NO_PERL=1 NO_CURL=1 NO_EXPAT=1 NO_TCLTK=1 NO_ICONV=1 prefix= DESTDIR=installed-tree
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/build-stamp: rsync.patch
	# This is a known-good version that the patch works with.
	cat rsync.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && git reset --hard eec26089b1c7bdbb260674480ffe6ece257bca63 && git am)
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/automake/lib/config.sub $(GIT_ANNEX_ANDROID_SOURCETREE)/automake/lib/config.guess $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && ./configure --host=arm-linux-androideabi --disable-locale --disable-iconv-open --disable-iconv --disable-acl-support --disable-xattr-support
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && git checkout gnupg-1.4.15
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./autogen.sh
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./configure --host=arm-linux-androideabi --disable-gnupg-iconv --disable-card-support --disable-agent-support --disable-photo-viewers --disable-keyserver-helpers --disable-nls
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg; $(MAKE) || true # expected failure in doc build
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp: term.patch icons
	# This is a known-good version that the patch works with.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && git reset --hard 3d34b3c42295c215b62e70f3ee696dd664ba08ce
	cat term.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && patch -p1)
	(cd icons && tar c .) | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term/res && tar x)
	# This renaming has a purpose. It makes the path to the app's
	# /data directory shorter, which makes ssh connection caching
	# sockets placed there have more space for their filenames.
	# Also, it avoids overlap with the Android Terminal Emulator
	# app, if it's also installed.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && find -name .git -prune -o -type f -print0 | xargs -0 perl -pi -e 's/jackpal/ga/g'
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && perl -pi -e 's/Terminal Emulator/Git Annex/g' res/*/strings.xml
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && echo y | tools/update.sh
	touch $@

source: $(GIT_ANNEX_ANDROID_SOURCETREE)

$(GIT_ANNEX_ANDROID_SOURCETREE):
	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)
	git clone git://git.savannah.gnu.org/automake.git $(GIT_ANNEX_ANDROID_SOURCETREE)/automake
	git clone git://git.debian.org/git/d-i/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox
	git clone git://git.kernel.org/pub/scm/git/git.git $(GIT_ANNEX_ANDROID_SOURCETREE)/git
	git clone git://git.samba.org/rsync.git $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync
	git clone git://git.gnupg.org/gnupg.git $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg
	git clone git://git.openssl.org/openssl $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl
	git clone git://github.com/CyanogenMod/android_external_openssh.git $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh
	git clone git://github.com/jackpal/Android-Terminal-Emulator.git $(GIT_ANNEX_ANDROID_SOURCETREE)/term

clean:
	rm -rf $(GITTREE)
	rm -f start

reallyclean: clean
	rm -rf $(GIT_ANNEX_ANDROID_SOURCETREE)

=== debian/changelog ===
git-annex (4.20131106) unstable; urgency=low

  * Improve local pairing behavior when two computers both try to start
    the pairing process separately.
  * sync: Work even when the local git repository is new and empty,
    with no master branch.
  * gcrypt, bup: Fix bug that prevented using these special remotes
    with encryption=pubkey.
  * Fix enabling of gcrypt repository accessed over ssh;
    git-annex-shell gcryptsetup had a bug that caused it to fail
    with permission denied.
  * Fix zombie process that occurred when switching between repository
    views in the webapp.
  * map: Work when there are gcrypt remotes.
  * Fix build w/o webapp.
  * Fix exception handling bug that could cause .git/annex/index to be used
    for git commits outside the git-annex branch. Known to affect git-annex
    when used with the git shipped with Ubuntu 13.10.

 -- Joey Hess <joeyh@debian.org>  Wed, 06 Nov 2013 11:17:47 -0400

## git-annex 5.20131118

=== Makefile ===
--- 
+++ 
@@ -83,8 +83,8 @@
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs \
 		git-union-merge git-recover-repository
-	find -name \*.o -exec rm {} \;
-	find -name \*.hi -exec rm {} \;
+	find . -name \*.o -exec rm {} \;
+	find . -name \*.hi -exec rm {} \;
 
 Build/InstallDesktopFile: Build/InstallDesktopFile.hs
 	$(GHC) --make $@
@@ -162,10 +162,11 @@
 
 	./Build/OSXMkLibs $(OSXAPP_BASE)
 	rm -f tmp/git-annex.dmg
-	hdiutil create -size 640m -format UDRW -srcfolder tmp/build-dmg \
+	hdiutil create -format UDBZ -srcfolder tmp/build-dmg \
 		-volname git-annex -o tmp/git-annex.dmg
+	# temporarily still create compressed image too
 	rm -f tmp/git-annex.dmg.bz2
-	bzip2 --fast tmp/git-annex.dmg
+	bzip2 --fast < tmp/git-annex.dmg > tmp/git-annex.dmg.bz2
 
 ANDROID_FLAGS?=-f-XMPP
 # Cross compile for Android.
@@ -189,14 +190,16 @@
 	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
 # Cabal cannot cross compile with custom build type, so workaround.
 	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
+# Build just once, but link twice, for 2 different versions of Android.
+	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3
 	if [ ! -e tmp/androidtree/dist/setup/setup ]; then \
-		cd tmp/androidtree && $$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
+		cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
 	fi
-	cd tmp/androidtree && $$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal build
-
-adb:
-	ANDROID_FLAGS="-Production" $(MAKE) android
-	adb push tmp/androidtree/dist/build/git-annex/git-annex /data/data/ga.androidterm/bin/git-annex
+	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
+		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.0/git-annex
+	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
+		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc \
+		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.3/git-annex
 
 androidapp:
 	$(MAKE) android

=== debian/changelog ===
git-annex (5.20131118) unstable; urgency=low

  * Direct mode repositories now have core.bare=true set, to prevent
    accidentally running git commands that try to operate on the work tree,
    and so do the wrong thing in direct mode.
  * annex.version is now set to 5 for direct mode repositories.
    This upgrade is handled fully automatically, no need to run
    git annex upgrade
  * The "status" command has been renamed to "info", to allow
    "git annex status" to be used in direct mode repositories, now that
    "git status" won't work in them.
  * The -c option now not only modifies the git configuration seen by
    git-annex, but it is passed along to every git command git-annex runs.
  * watcher: Avoid loop when adding a file owned by someone else fails
    in indirect mode because its permissions cannot be modified.
  * webapp: Avoid encoding problems when displaying the daemon log file.
  * webapp: Improve UI around remote that have no annex.uuid set,
    either because setup of them is incomplete, or because the remote
    git repository is not a git-annex repository.
  * Include ssh-keygen in standalone bundle.
  * Allow optionally configuring git-annex with -fEKG to enable awesome
    remote monitoring interfaceat http://localhost:4242/
  * Fix bug that caused bad information to be written to the git-annex branch
    when running describe or other commands with a remote that has no uuid.
  * Work around Android linker problem that had prevented git-annex from
    running on Android 4.3 and 4.4.
  * repair: Handle case where index file is corrupt, but all objects are ok.
  * assistant: Notice on startup when the index file is corrupt, and
    auto-repair.
  * Fix direct mode merge bug when a direct mode file was deleted and replaced
    with a directory. An ordering problem caused the directory to not get
    created in this case.
    Thanks to Tim for the test case.
  * Direct mode .git/annex/objects directories are no longer left writable,
    because that allowed writing to symlinks of files that are not present,
    which followed the link and put bad content in an object location.
    Thanks to Tim for the test case.
  * fsck: Fix up .git/annex/object directory permissions.
  * Switched to the tasty test framework.
  * Android: Adjust default .gitignore to ignore .thumbnails at any location
    in the tree, not just at its top.
  * webapp: Check annex.version.

 -- Joey Hess <joeyh@debian.org>  Mon, 18 Nov 2013 10:45:43 -0400

## git-annex 5.20131120

=== Makefile ===
--- 
+++ 
@@ -30,11 +30,7 @@
 # These are not built normally.
 git-union-merge.1: doc/git-union-merge.mdwn
 	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
-git-recover-repository.1: doc/git-recover-repository.mdwn
-	./Build/mdwn2man git-recover-repository 1 doc/git-recover-repository.mdwn > git-recover-repository.1
 git-union-merge:
-	$(GHC) --make -threaded $@
-git-recover-repository:
 	$(GHC) --make -threaded $@
 
 install-mans: $(mans)
@@ -82,7 +78,7 @@
 		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs \
-		git-union-merge git-recover-repository
+		git-union-merge
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;

=== standalone/android/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # and builds the Android app.
 
 # Add Android cross-compiler to PATH (as installed by ghc-android)
-ANDROID_CROSS_COMPILER?=$(HOME)/.ghc/android-14/arm-linux-androideabi-4.7/bin
+ANDROID_CROSS_COMPILER?=$(HOME)/.ghc/$(shell cat abiversion)/bin
 PATH:=$(ANDROID_CROSS_COMPILER):$(PATH)
 
 # Paths to the Android SDK and NDK.
@@ -31,7 +31,6 @@
 	# Install executables as pseudo-libraries so they will be
 	# unpacked from the .apk.
 	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi
-	cp ../../tmp/androidtree/dist/build/git-annex/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.busybox.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh-keygen $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh-keygen.so
@@ -74,9 +73,15 @@
 
 	git rev-parse HEAD > $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.version.so
 
+	mkdir -p ../../tmp/4.0 ../../tmp/4.3
+	
+	cp ../../tmp/androidtree/dist/build/git-annex/4.3/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
-	mkdir -p ../../tmp
-	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/git-annex.apk
+	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/4.3/git-annex.apk
+	
+	cp ../../tmp/androidtree/dist/build/git-annex/4.0/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
+	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
+	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/4.0/git-annex.apk
 
 $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp:
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && CC=$$(which cc) ./Configure android

=== debian/changelog ===
git-annex (5.20131120) unstable; urgency=low

  * Fix Debian package to not try to run test suite, since haskell-tasty
    is not out of new or in Build-Depends yet.
  * dropunused, addunused: Allow "all" instead of a range to
    act on all unused data.
  * Ensure execute bit is set on directories when core.sharedrepository is set.
  * Ensure that core.sharedrepository is honored when creating the .git/annex
    directory.
  * Improve repair code in the case where the index file is corrupt,
    and this hides other problems from git fsck.

 -- Joey Hess <joeyh@debian.org>  Wed, 20 Nov 2013 12:54:18 -0400

## git-annex 5.20131127

=== debian/changelog ===
git-annex (5.20131127) unstable; urgency=low

  * webapp: Detect when upgrades are available, and upgrade if the user
    desires.
    (Only when git-annex is installed using the prebuilt binaries
    from git-annex upstream, not from eg Debian.)
  * assistant: Detect when the git-annex binary is modified or replaced,
    and either prompt the user to restart the program, or automatically
    restart it.
  * annex.autoupgrade configures both the above upgrade behaviors.
  * Added support for quvi 0.9. Slightly suboptimal due to limitations in its
    interface compared with the old version.
  * Bug fix: annex.version did not get set on automatic upgrade to v5 direct
    mode repo, so the upgrade was performed repeatedly, slowing commands down.
  * webapp: Fix bug that broke switching between local repositories
    that use the new guarded direct mode.
  * Android: Fix stripping of the git-annex binary.
  * Android: Make terminal app show git-annex version number.
  * Android: Re-enable XMPP support.
  * reinject: Allow to be used in direct mode.
  * Futher improvements to git repo repair. Has now been tested in tens
    of thousands of intentionally damaged repos, and successfully
    repaired them all.
  * Allow use of --unused in bare repository.

 -- Joey Hess <joeyh@debian.org>  Wed, 27 Nov 2013 18:41:44 -0400

## git-annex 5.20131127.1

=== Makefile ===
--- 
+++ 
@@ -77,7 +77,7 @@
 	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
 		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
-		Build/Standalone Build/OSXMkLibs \
+		Build/Standalone Build/OSXMkLibs Build/DistributionUpdate \
 		git-union-merge
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;
@@ -133,6 +133,8 @@
 	sort "$(LINUXSTANDALONE_DEST)/libdirs.tmp" | uniq > "$(LINUXSTANDALONE_DEST)/libdirs"
 	rm -f "$(LINUXSTANDALONE_DEST)/libdirs.tmp"
 
+	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
+	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
 	cd tmp && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux
 
 OSXAPP_DEST=tmp/build-dmg/git-annex.app
@@ -157,19 +159,18 @@
 	install -d "$(OSXAPP_BASE)/templates"
 
 	./Build/OSXMkLibs $(OSXAPP_BASE)
+	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
+	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
 	rm -f tmp/git-annex.dmg
 	hdiutil create -format UDBZ -srcfolder tmp/build-dmg \
 		-volname git-annex -o tmp/git-annex.dmg
-	# temporarily still create compressed image too
-	rm -f tmp/git-annex.dmg.bz2
-	bzip2 --fast < tmp/git-annex.dmg > tmp/git-annex.dmg.bz2
-
-ANDROID_FLAGS?=-f-XMPP
+
+ANDROID_FLAGS?=
 # Cross compile for Android.
 # Uses https://github.com/neurocyte/ghc-android
 android: Build/EvilSplicer
 	echo "Running native build, to get TH splices.."
-	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS);  fi
+	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
 	mkdir -p tmp
 	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
 	echo "Setting up Android build tree.."
@@ -188,7 +189,7 @@
 	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
 # Build just once, but link twice, for 2 different versions of Android.
 	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3
-	if [ ! -e tmp/androidtree/dist/setup/setup ]; then \
+	if [ ! -e tmp/androidtree/dist/setup-config ]; then \
 		cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
 	fi
 	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
@@ -220,4 +221,8 @@
 	hdevtools --stop-server || true
 	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports
 
+distributionupdate:
+	ghc --make Build/DistributionUpdate
+	./Build/DistributionUpdate
+
 .PHONY: git-annex git-union-merge git-recover-repository tags build-stamp

=== standalone/android/Makefile ===
--- 
+++ 
@@ -15,6 +15,8 @@
 
 GITTREE=$(GIT_ANNEX_ANDROID_SOURCETREE)/git/installed-tree
 
+VER=$(shell perl -e '$$_=<>;print m/\((.*?)\)/'<../../CHANGELOG)
+
 build: start
 	if [ ! -e "$(GIT_ANNEX_ANDROID_SOURCETREE)" ]; then $(MAKE) source; fi
 	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp
@@ -25,6 +27,8 @@
 	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp
 	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp
 
+	perl -i -pe 's/(android:versionName=)"[^"]+"/$$1"'$(VER)'"/' $(GIT_ANNEX_ANDROID_SOURCETREE)/term/AndroidManifest.xml
+	
 	# Debug build because it does not need signing keys.
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && tools/build-debug
 
@@ -76,10 +80,12 @@
 	mkdir -p ../../tmp/4.0 ../../tmp/4.3
 	
 	cp ../../tmp/androidtree/dist/build/git-annex/4.3/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
+	arm-linux-androideabi-strip --strip-unneeded --remove-section=.comment --remove-section=.note $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/4.3/git-annex.apk
-	
+
 	cp ../../tmp/androidtree/dist/build/git-annex/4.0/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
+	arm-linux-androideabi-strip --strip-unneeded --remove-section=.comment --remove-section=.note $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/4.0/git-annex.apk

=== debian/changelog ===
git-annex (5.20131127.1) unstable; urgency=low

  * Rebuild that does not try to use quvi 0.9 from experimental.

 -- Joey Hess <joeyh@debian.org>  Thu, 28 Nov 2013 07:57:36 -0400

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-sha-dev,
	libghc-cryptohash-dev,
	libghc-regex-tdfa-dev [!mips !mipsel !s390],
	libghc-dataenc-dev,
	libghc-utf8-string-dev,
	libghc-hs3-dev (>= 0.5.6),
	libghc-dav-dev (>= 0.3) [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc sparc],
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-monadcatchio-transformers-dev,
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-aeson-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-extensible-exceptions-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.3) [linux-any],
	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc sparc],
	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-wai-logger-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-http-dev,
	libghc-feed-dev,
	ikiwiki,
	perlmagick,
	git (>= 1:1.8.4),
	rsync,
	wget,
	curl,
	openssh-client,
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.4
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.4),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: lsof, gnupg, bind9-host, ssh-askpass, quvi, git-remote-gcrypt (>= 0.20130908-4)
Suggests: graphviz, bup, libnss-mdns
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 Even without file content tracking, being able to manage files with git,
 move files around and delete files with versioned directory trees, and use
 branches and distributed clones, are all very handy reasons to use git. And
 annexed files can co-exist in the same git repository with regularly
 versioned files, which is convenient for maintaining documents, Makefiles,
 etc that are associated with annexed files but that benefit from full
 revision control.

=== debian/rules ===
#!/usr/bin/make -f

# Avoid using cabal, as it writes to $HOME
export CABAL=./Setup

# Do use the changelog's version number, rather than making one up.
export RELEASE_BUILD=1

%:
	dh $@

override_dh_auto_test:
	echo test suite currently disabled until haskell-tasty is out of NEW

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 5.20131130

=== debian/changelog ===
git-annex (5.20131130) unstable; urgency=low

  * init: Fix a bug that caused git annex init, when run in a bare
    repository, to set core.bare=false.

 -- Joey Hess <joeyh@debian.org>  Sat, 30 Nov 2013 16:32:35 -0400

## git-annex 5.20131213

=== debian/changelog ===
git-annex (5.20131213) unstable; urgency=low

  * Avoid using git commit in direct mode, since in some situations
    it will read the full contents of files in the tree.
  * assistant: Batch jobs are now run with ionice and nocache, when
    those commands are available.
  * assistant: Run transferkeys as batch jobs.
  * Automatically fix up bad bare repositories created by
    versions 5.20131118 through 5.20131127.
  * rsync special remote: Fix fallback mode for rsync remotes that
    use hashDirMixed. Closes: #731142
  * copy --from, get --from: When --force is used, ignore the
    location log and always try to get the file from the remote.
  * Deal with box.com changing the url of their webdav endpoint.
  * Android: Fix SRV record lookups for XMPP to use android getprop
    command to find DNS server, since there is no resolv.conf.
  * import: Add --skip-duplicates option.
  * lock: Require --force. Closes: #731606
  * import: better handling of overwriting an existing file/directory/broken
    link when importing
  * Windows: assistant and webapp work! (very experimental)
  * Windows: Support annex.diskreserve.
  * Fix bad behavior in Firefox, which was caused by an earlier fix to
    bad behavior in Chromium.
  * repair: Improve repair of git-annex index file.
  * repair: Remove damaged git-annex sync branches.
  * status: Ignore new files that are gitignored.
  * Fix direct mode's handling when modifications to non-annexed files
    are pulled from a remote. A bug prevented the files from being updated
    in the work tree, and this caused the modification to be reverted.
  * OSX: Remove ssh and ssh-keygen from dmg as they're included in OSX by
    default.

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Dec 2013 14:20:32 -0400

=== debian/control ===
--- 
+++ 
@@ -73,7 +73,14 @@
 	wget,
 	curl,
 	openssh-client (>= 1:5.6p1)
-Recommends: lsof, gnupg, bind9-host, ssh-askpass, quvi, git-remote-gcrypt (>= 0.20130908-4)
+Recommends: 
+	lsof,
+	gnupg,
+	bind9-host,
+	ssh-askpass,
+	quvi,
+	git-remote-gcrypt (>= 0.20130908-4),
+	nocache
 Suggests: graphviz, bup, libnss-mdns
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file
